function love.load()
	imageData = love.image.newImageData(1, 1) -- There's probably a better way to do this
	image = love.graphics.newImage(imageData) -- if someone more experienced knows, please improve it.
	
	HSVold = [[
		vec3 HSV(float h, float s, float v)
		{
			if (s <= 0 ) { return vec3 (0.0); }
			h = h * 6;
			float c = v*s;
			float x = (1-abs((mod(h,2)-1)))*c;
			float m = v-c;
			float r = 0.0;
			float g = 0.0;
			float b = 0.0;

			if (h < 1) { r = c; g = x;b = 0.0;}
			else if (h < 2) { r = x; g = c; b = 0.0; }
			else if (h < 3) { r = 0.0; g = c; b = x; }
			else if (h < 4) { r = 0.0; g = x; b = c; }
			else if (h < 5) { r = x; g = 0.0; b = c; }
			else  { r = c; g = 0.0; b = x; }

			return vec3(r+m,g+m,b+m);
		}
	]] -- yuck
	HSVnew = [[
		vec3 HSV(float h,float s,float v)
		{
			return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
		}
	]] -- compact
	
	entryPart = [[
		extern float time; // Extra part
		
		vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords)
		{
			return vec4(HSV(texture_coords.x + time, 1.0, 1.0), 1.0);
			//return vec4(HSV(sin(texture_coords.x * 10.0) + cos(texture_coords.y * 10.0) + time, 1.0, 1.0), 1.0); // Another easter egg ;)
		}
	]] -- entry point of effect, required.
	
	-- effect = love.graphics.newPixelEffect(HSVold .. entryPart) -- You can play around with these lines to make sure both effects work the same.
	effect = love.graphics.newPixelEffect(HSVnew .. entryPart)
	
	-- just concatenate two strings to make a shader. Awesome, isn't it?
	
	time = 0
end

function love.update(dt)
	time = (time + dt) % (math.pi * 2) -- Hue goes in a circle (open any decent image editor to see). Or, in other words, wraps at 360 deg or at pi*2 rad
	effect:send("time", time)
end

function love.draw()
	love.graphics.setPixelEffect(effect)
	love.graphics.draw(image, 0, 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
	love.graphics.setPixelEffect()
end

function love.keypressed(key)
	if key == "escape" then love.event.push("quit") end
end